<?php
class UsersController extends AppController {
    public $helpers = array ('Html','Form');
    public $name = 'Users';
	
    public function beforeFilter() {
        parent::beforeFilter();
        $this->Auth->allow('logout');
    }	
	
	public function index() {
		$this->set('user', $this->Auth->user());
        //debug ($this->User->find('all'));
        $this->set('users', $this->User->find('all', array('order' => array('User.id'))));
		
    }	
	
    public function add() {
		$this->set('user', $this->Auth->user());
        if ($this->request->is('post')) {
            if ($this->User->save($this->request->data)) {
				if($this->request->data['User']['role'] == 'staff'){
					$this->request->data['Staff']['user_id'] = $this->User->getLastInsertID();
					if($this->User->Staff->save($this->request->data)){
						$this->Session->setFlash('Your user has been saved.');
						$this->redirect(array('action' => 'index'));
					}
				}else{
					$this->Session->setFlash('Tu usuario ha sido guardado');
					$this->redirect(array('action' => 'index'));
				}
            }
        }
		$this->set('departments', $this->User->Department->find('list'));
    }	
	
	public function edit($id = null) {
		$this->User->id = $id;
		//debug ($this->User->read());
		if ($this->request->is('get')) {
			$this->request->data = $this->User->read();
		} else {
			if ($this->User->save($this->request->data)) {
				$this->Session->setFlash('Tu usuario ha sido actualizado');
				$this->redirect(array('action' => 'index'));
            } else {
                $this->Session->setFlash(__('Error al guardar usuario, prueba de nuevo.'));
            }
		}
	}
	
	public function delete($id) {
		if (!$this->request->is('post')) {
			throw new MethodNotAllowedException();
		}
        $this->User->id = $id;
        if (!$this->User->exists()) {
            throw new NotFoundException(__('Invalid user'));
        }		
		if ($this->User->delete($id)) {
			$this->Session->setFlash('El usuario: ' . $id . ' ha sido borrado.');
			$this->redirect(array('action' => 'index'));
		}
        $this->Session->setFlash(__('Usuario no borrado.'));
        $this->redirect(array('action' => 'index'));		
	}
	
	public function login() {
		if ($this->Auth->login()) {
			$this->redirect($this->Auth->redirect());
		} else {
			//$this->Session->setFlash(__('Usuario o contraseña invalido, prueba de nuevo.'));
		}
	}

	public function logout() {
		$this->redirect($this->Auth->logout());
	}
}
?>