<?php

class Ticket extends AppModel {
    public $name = 'Ticket';
	public $actsAs = array('Containable');
    public $belongsTo = array(
        'Department' => array(
            'className'    => 'Department',
            'foreignKey'   => 'department_id'
        ),
        'User' => array(
            'className'    => 'User',
            'foreignKey'   => 'user_id'
        )		
    );	
    public $hasMany = array(
        'Answer' => array(
            'className'    => 'Answer',
            'foreignKey'   => 'ticket_id'
        ),
        'Question' => array(
            'className'    => 'Question',
            'foreignKey'   => 'ticket_id'
        )			
    );		
	
	public $validate = array(
		'topic' => array(
			'notEmpty' => array(
				'rule' => 'notEmpty',
				'message' => 'Este campo es necesario'
			)
		),
		'description' => array(
			'notEmpty' => array(
				'rule' => 'notEmpty',
				'message' => 'Este campo es necesario'
			)
		)
	);
}

?>