<?php

class User extends AppModel {
    public $name = 'User';
    public $hasAndBelongsToMany = array(
        'Department' =>
            array(
                'className'              => 'Department',
                'joinTable'              => 'staffs',
                'foreignKey'             => 'user_id',
                'associationForeignKey'  => 'department_id',
                'unique'                 => true,
                'conditions'             => '',
                'fields'                 => '',
                'order'                  => '',
                'limit'                  => '',
                'offset'                 => '',
                'finderQuery'            => '',
                'deleteQuery'            => '',
                'insertQuery'            => ''
            )
    );	
	public $validate = array(
		'username' => array(
			'rule' => 'notEmpty'
		),
		'password' => array(
			'rule' => 'notEmpty'
		)
	);
	
	public function beforeSave() {
		if (isset($this->data[$this->alias]['password'])) {
			$this->data[$this->alias]['password'] = AuthComponent::password($this->data[$this->alias]['password']);
		}
		return true;
	}
}

?>